#Ifndef edge_t_bi
#Define edge_t_bi

#Include "vector_4d.bi"
#Include "matrix_4d.bi"
#Include "quaternion_4d.bi"
#Include "vertex.bi"
#Include "gradiens.bi"

Type edge
	Protected:
	Private:
	m_x As Single
	m_xstep As Single
	m_ystart As Single
	m_yend As Single
	
	m_texcoordx As Single
	m_texcoordy As Single
	m_texcoordxstep As Single
	m_texcoordystep As Single
	
	m_oneOverZ As Single
	m_oneOverZStep As Single
	
	m_color As vector_4d
	m_colorstep As vector_4d
	
	m_depth As Single
	m_depthStep As Single
	
	m_lightAmt As Single
	m_lightAmtStep As Single
	
	Public:
	'Declare Constructor ()
	Declare Constructor(gradiens As gradient_t Ptr ,minYvert As vertex_t, maxYvert As vertex_t, minYvertIndex As uinteger)
	Declare Destructor()
	
	Declare Function GetX() As Single
	Declare Function GetYStart() As Single
	Declare Function GetYEnd() As Single
	Declare Function GetColor() As vector_4d
	Declare Function GetTexCoordX() As Single
	Declare Function GetTexCoordY() As Single
	Declare Function GetOneOverZ() As Single
	Declare Function GetOneOverZStep() As Single
	Declare Function GetDepth() As Single
	Declare Function GetLightAmt() As Single
	Declare Function Clone() As edge
	Declare Sub Steps()

End Type
'Constructor edge()
'	m_x=0
'	m_xstep=0
'	m_ystart=0
'	m_yend=1
'End Constructor
Constructor edge(gradiens As gradient_t ptr,minYvert As vertex_t, maxYvert As vertex_t, minYVertIndex As uinteger)
	m_ystart=(minYvert.GetY())'+0.5)'Ceil(minYvert.GetY())
	m_yend=	(maxYvert.GetY())'+0.5)'Ceil(maxYvert.GetY())

	Dim As Single ydist = maxYvert.GetY()-minYvert.GetY()
	Dim As Single xdist = maxYvert.GetX()-minYvert.GetX()

	Dim yprestep As Single=m_ystart-minYvert.GetY()
	m_xstep 	= (xdist)/(ydist)
	m_x		= minYvert.GetX()+(yprestep*m_xstep)'+1))
	If m_x<100 Then
		Print m_x
	EndIf
	Dim xprestep As Single = m_x-minYvert.GetX()	

	m_color	=	gradiens->GetColor(minYVertIndex).Addi( _
					gradiens->GetColorYStep().Mult(yprestep)).Addi( _
					gradiens->GetColorXStep().Mult(xprestep))
					
	m_colorStep	=	gradiens->GetColorYStep().Addi(gradiens->GetColorXStep().Mult(m_xstep))
	
	m_texCoordX = 	gradiens->GetTexCoordX(minYVertIndex) + _
						gradiens->GetTexCoordXXStep() * xPrestep + _
						gradiens->GetTexCoordXYStep() * yPrestep
			
	m_texcoordxstep = gradiens->GetTexCoordXYStep() + gradiens->GetTexCoordXXStep() * m_xStep

	m_texcoordy = 	gradiens->GetTexCoordY(minYVertIndex) + _
						gradiens->GetTexCoordYXStep() * xPrestep + _
						gradiens->GetTexCoordYYStep() * yPrestep
						
	m_texcoordystep = gradiens->GetTexCoordYYStep() + gradiens->GetTexCoordYXStep() * m_xStep

	m_oneOverZ = 	gradiens->GetOneOverZ(minYVertIndex) + _
						gradiens->GetOneOverZYStep() * xPrestep + _
						gradiens->GetOneOverZXStep() * yPrestep
						
	m_oneOverZStep = gradiens->GetOneOverZYStep() + gradiens->GetOneOverZXStep() * m_xStep
	
	m_depth =	gradiens->GetDepth(minYVertIndex) + _
					gradiens->GetDepthXStep() * xPrestep + _
					gradiens->GetDepthYStep() * yPrestep
	m_depthStep = gradiens->GetDepthYStep() + gradiens->GetDepthXStep() * m_xStep

	m_lightAmt =gradiens->GetLightAmt(minYVertIndex) + _
					gradiens->GetLightAmtXStep() * xPrestep + _
					gradiens->GetLightAmtYStep() * yPrestep
	m_lightAmtStep = gradiens->GetLightAmtYStep() + gradiens->GetLightAmtXStep() * m_xStep
End Constructor
Destructor edge()

End Destructor
Function edge.Clone() As edge
	Return This
End Function
Function edge.GetX() As Single
	Return m_x
End Function
Function edge.GetYStart() As Single
	Return m_ystart
End Function
Function edge.GetYEnd() As single
	Return m_yend
End Function
Function edge.GetTexCoordX() As Single
	Return m_texcoordx
End Function
Function edge.GetTexCoordY() As Single
	Return m_texcoordy
End Function
Function edge.GetOneOverZ() As Single
	Return m_oneOverZ
End Function
Function edge.GetOneOverZStep() As Single
	Return m_oneOverZStep
End Function
Function edge.GetColor() As vector_4d
	Return m_color
End Function
Function edge.GetDepth() As Single
	Return m_depth
End Function
Function edge.GetlightAmt() As Single
	Return m_lightAmt
End Function
Sub edge.Steps()
	m_x+=m_xstep
	m_color=m_color.Addi(m_colorstep)
	m_texcoordx+=m_texcoordxstep
	m_texcoordy+=m_texcoordystep
	m_oneOverZ+=m_oneOverZStep
	m_depth += m_depthStep
	m_lightAmt += m_lightAmtStep
End Sub
#EndIf