#Ifndef rendercontext_t_bi
#Define rendercontext_t_bi
#Include "edge.bi"
#Include "gradiens.bi"
#Include "texture.bi"
#Include Once "inc/md/util/mdlist.bi"
mdListDeclare(vertex_t)
mdIteratorDeclare(vertex_t)

Type rendercontext_t' EXTENDS Object
	Protected:
	Private:
	m_bits 	As UInteger
	scr		As ubyte Ptr
	
	Public:
	m_width  As UInteger
	m_height As UInteger
	size 		As UInteger
	m_zbuffer  As single Ptr
	m_fov		As Single
	use_textures As UInteger
	use_wireframe As UInteger
	use_backfaceculling As UInteger
	rendered_tris As UInteger
	rendered_pixels As uinteger

	Declare Constructor()
	Declare Constructor(s_width As UInteger,s_height As UInteger,FOV As Single)
	Declare Destructor()
	Declare function GetFrameBuffer() As UByte Ptr
	Declare Sub ClearZBuffer()
	Declare Sub SetFOV(fov As Single)
	Declare Sub Clear(a As UByte,r As UByte,g As UByte,b As UByte)
	Declare Sub DrawPixel(x As UInteger,y As UInteger,a As UByte,r As UByte,g As UByte,b As UByte, light As single)
	Declare Sub CopyPixel(x As UInteger,y As UInteger,scrX As UInteger, scrY As UInteger, texture As texture_t Ptr,col As vector_4d, light As Single)

	Declare Sub DrawScanLine(gradiens As gradient_t ptr,lefts As edge Ptr,rights As edge Ptr, j As uInteger,texture As texture_t Ptr)
	Declare Sub FillTriangle(v1 As vertex_t,v2 As vertex_t,v3 As vertex_t,texture As texture_t Ptr)
	Declare Sub ScanTriangle(minYvert As vertex_t, midYvert As vertex_t, maxYvert As vertex_t, handedness As UInteger,texture As texture_t Ptr)
	Declare Sub ScanEdges(gradiens As gradient_t Ptr,a As edge Ptr,b As edge Ptr,handedness As UInteger,texture As texture_t Ptr)
	Declare Sub DrawTriangle(v1 As vertex_t, v2 As vertex_t, v3 As vertex_t, texture As texture_t ptr)
	declare Sub DrawQuad(v1 As vertex_t, v2 As vertex_t, v3 As vertex_t, v4 as vertex_t, texture As texture_t ptr)

	Declare Sub ClipPolygonComponent(vertices As mdList(vertex_t) , componentIndex As uinteger, componentFactor As single,result As mdList(vertex_t))
	Declare Function ClipPolygonAxis(vertices As mdList(vertex_t) , auxillaryList As mdList(vertex_t), componentIndex As UInteger) As boolean
End Type
Constructor rendercontext_t()
m_width	=	800
m_height	=	600
ScreenRes (m_width,m_height,32,2,GFX_ALPHA_PRIMITIVES)
scr		=	ScreenPtr
m_bits=4
size=m_width*m_height*m_bits
m_zbuffer=New Single[m_width*m_height]
m_fov=90
use_textures=0
use_wireframe=0
use_backfaceculling=0
rendered_tris=0
rendered_pixels=0

End Constructor
Constructor rendercontext_t(s_width As UInteger, s_height As UInteger,FOV As Single)
m_width	=	s_width
m_height	=	s_height
ScreenRes (m_width,m_height,32,2,GFX_ALPHA_PRIMITIVES)
scr		=	ScreenPtr
m_bits=4
size=m_width*m_height*m_bits
m_zbuffer=New Single[m_width*m_height]
m_fov=FOV
use_textures=0
use_wireframe=0
use_backfaceculling=0
rendered_tris=0
rendered_pixels=0
End Constructor
Destructor rendercontext_t()
Delete [] m_zbuffer
End Destructor
Sub rendercontext_t.SetFOV(fov As Single)
	m_fov=fov*M_PI/180.0
End Sub
Function rendercontext_t.GetFrameBuffer() As Ubyte ptr
	Return scr
End Function
Sub rendercontext_t.ClearZBuffer()
	For i As UInteger=0 To m_width*m_height-1
		m_zbuffer[i]=1e+37
	next
End Sub

Sub rendercontext_t.DrawPixel(x As UInteger,y As UInteger,a As UByte,r As UByte,g As UByte,b As UByte, light As Single)
		If x>=0 Andalso y>=0 Andalso x<m_width Andalso y<m_height Then
			Dim dest As UInteger=(y*m_width+x)*m_bits
			scr[dest+3]=((a * a + scr[dest+3] * (255 - a)) Shr 8)'* light'/ 255
			scr[dest+2]=((r * a + scr[dest+2] * (255 - a)) Shr 8)* light' / 255
			scr[dest+1]=((g * a + scr[dest+1] * (255 - a)) Shr 8)* light' / 255
			scr[dest+0]=((b * a + scr[dest+0] * (255 - a)) Shr 8)* light' / 255
		EndIf
End Sub
Sub rendercontext_t.CopyPixel(x As UInteger,y As UInteger,scrX As UInteger, scrY As UInteger, texture As texture_t Ptr,col As vector_4d,light As Single)
	'If texture=0 Then 
	'	DrawPixel(x,y,col.GetW()*255,col.GetX()*255,col.GetY()*255,col.GetZ()*255,light)
	'	Exit sub
	'EndIf
	'If x > m_width-1 Orelse y > m_height-1 OrElse x < 0 Orelse y < 0 OrElse _
	'	scrX > texture->GetWidth() OrElse scrY > texture->GetHeight() OrElse scrX < 0 OrElse scrY < 0 then
	'	Exit Sub
	'Else
		Dim dest As UInteger=(y*m_width+x)*m_bits
		Dim sour As UInteger=(scrY*texture->GetWidth()+scrX)*texture->GetDepth()
		'OutP = (( DisplayPlane.Alpha / 255 ) * DisplayPlane.RGB) + (((255 DisplayPlane.Alpha)/255) * OverlayPlane.RGB)

		'R' = R1 + f * (R2 - R1)
		'G' = G1 + f * (G2 - G1)
		'B' = B1 + f * (B2 - B1)
		Dim As Single a2,r2,g2,b2
		Dim As Single a1,r1,g1,b1
		Dim As Single a,r,g,b
		a2=scr[dest+3]/255
		a=col.GetW()
		r1=scr[dest+2]/255
		r2=col.GetX()
		r=r1+a*(r2-r1)

		g1=scr[dest+1]/255
		g2=col.GetY()
		g=g1+a*(g2-g1)

		b1=scr[dest+0]/255
		b2=col.GetZ()
		b=b1+a*(b2-b1)

		a=1-texture->GetPixData()[sour+3]/255
		r1=r
		r2=texture->GetPixData()[sour+2]/255
		r=r1+a*(r2-r1)

		g1=g
		g2=texture->GetPixData()[sour+1]/255
		g=g1+a*(g2-g1)

		b1=b
		b2=texture->GetPixData()[sour+0]/255
		b=b1+a*(b2-b1)

		'r=r+scr[dest+3]/255*(scr[dest+2]/255-r)
		'g=g+scr[dest+3]/255*(scr[dest+1]/255-g)
		'b=b+scr[dest+3]/255*(scr[dest+0]/255-b)

		scr[dest+3]=a*255'* light'(a * a + scr[dest+3] * (255 - a)) Shr 8'/ 255
		scr[dest+2]=r*255* light'(r * a + scr[dest+2] * (255 - a)) Shr 8' / 255
		scr[dest+1]=g*255* light'(g * a + scr[dest+1] * (255 - a)) Shr 8' / 255
		scr[dest+0]=b*255* light'(b * a + scr[dest+0] * (255 - a)) Shr 8' / 255
	'endif

End Sub

Sub rendercontext_t.Clear(a As UByte,r As UByte,g As UByte,b As UByte)
	Line(0,0)-(m_width,m_height),RGBA(r,g,b,a),BF
	rendered_tris=0
	rendered_pixels=0
End Sub

'
'
'

Sub rendercontext_t.ScanTriangle(minYvert As vertex_t, midYvert As vertex_t, maxYvert As vertex_t, handedness As UInteger,texture As texture_t Ptr)
	Dim gradiens As gradient_t Ptr  = New gradient_t(minYvert,midYvert,maxYvert)
	Dim toptobottom As edge Ptr		=New edge(gradiens,minYvert,maxYvert,0)
	Dim toptomiddle As edge	Ptr		=New edge(gradiens,minYvert,midYvert,0)
	Dim middletobottom As edge	Ptr	=New edge(gradiens,midYvert,maxYvert,1)

	ScanEdges(gradiens, toptobottom,toptomiddle,handedness,texture)
	ScanEdges(gradiens, toptobottom,middletobottom,handedness,texture)
	rendered_tris+=1
	
	Delete gradiens
	Delete toptobottom
	Delete toptomiddle
	Delete middletobottom
End Sub
Sub rendercontext_t.ScanEdges(gradiens As gradient_t Ptr ,a As edge Ptr,b As edge Ptr,handedness As UInteger, texture As texture_t Ptr)
	Dim ystart As Integer
	Dim yend As Integer
	Dim lefts As edge Ptr	= a
	Dim rights As edge Ptr	= b
	If handedness<>0 Then
		Swap lefts,rights
	EndIf

	ystart=b->GetYStart()
	yend=b->GetYEnd()

	For j As UInteger=ystart To yend-1 Step 1
		'If j<m_width Or j>0 then
			DrawScanLine(gradiens,lefts,rights,j,texture)
		'endif
		lefts->Steps()
		rights->Steps()
	Next
End Sub

Sub rendercontext_t.DrawScanLine(gradiens As gradient_t Ptr,lefts As edge Ptr,rights As edge Ptr, j As uInteger,texture As texture_t Ptr)
	Dim xmin As Single=(lefts->GetX()+0.5)'Ceil(lefts->GetX())
	Dim xmax As single=(rights->GetX()+0.5)'Ceil(rights->GetX())
	'If xmax<xmin Then Swap xmax,xmin
	'If xmax>m_width Or xmax<0 Then 
	'	Print "exit DrawScanLine"
	'	Exit Sub
	'EndIf

	Dim xprestep As Single=xmin-lefts->GetX()
	Dim colors As vector_4d = lefts->GetColor().Addi(gradiens->GetColorXStep().Mult(xprestep))

	Dim As Single texCoordXXStep = gradiens->GetTexCoordXXStep()
	Dim As Single texCoordYXStep = gradiens->GetTexCoordYXStep()
	Dim As Single oneOverZXStep = gradiens->GetOneOverZXStep()

	Dim As Single depthXStep = gradiens->GetDepthXStep()

	Dim As single lightAmtXStep = gradiens->GetLightAmtXStep()

	Dim As Single texCoordX = lefts->GetTexCoordX() + texCoordXXStep * xprestep
	Dim As Single texCoordY = lefts->GetTexCoordY() + texCoordYXStep * xprestep
	Dim As Single oneOverZ = lefts->GetOneOverZ() + oneOverZXStep * xprestep
	Dim As Single depth = lefts->GetDepth() + depthXStep * xPrestep
	Dim As Single lightAmt = lefts->GetLightAmt() + lightAmtXStep * xPrestep
	If use_wireframe<>0 Then
			DrawPixel(xmin,j,colors.GetW()*255,colors.GetX()*255,colors.GetY()*255,colors.GetZ()*255,lightAmt )
			DrawPixel(xmax,j,colors.GetW()*255,colors.GetX()*255,colors.GetY()*255,colors.GetZ()*255,lightAmt )		
	else	
		For i As UInteger=xmin To xmax-1 Step 1
			Dim As uinteger index = i + j * m_width
			If(depth < m_zbuffer[index]) and colors.GetW()<1.0 Then'zbuffer test and alpha test
				m_zbuffer[index] = depth
				If use_textures<>0 Then
					Dim As Single z = 1.0/oneOverZ
					Dim srcX As Single=(((texCoordX * z) * (texture->GetWidth())+0.5) Mod (texture->GetWidth() ))
					Dim srcY As single=(((texCoordY * z) * (texture->GetHeight())+0.5) Mod (texture->GetHeight() ))
					CopyPixel(i,j,srcX,srcY,texture,colors,lightAmt)
					texCoordX+=texCoordXXStep
					texCoordY+=texCoordYXStep
					
				Else
					DrawPixel(i,j,colors.GetW()*255,colors.GetX()*255,colors.GetY()*255,colors.GetZ()*255,lightAmt )
				EndIf
					rendered_pixels+=1
			EndIf
			oneOverZ += oneOverZXStep
			colors = colors.Addi(gradiens->GetColorXStep())
			depth += depthXStep
			lightAmt += lightAmtXStep
		Next
	EndIf
End Sub
Sub rendercontext_t.FillTriangle(v1 As vertex_t,v2 As vertex_t,v3 As vertex_t,texture As texture_t Ptr)

	Dim M As matrix_4d
	Dim screenspacetransform As matrix_4d
	screenspacetransform = M.InitScreenSpaceTransform(this.m_width/2.0,this.m_height/2.0)
	
	Dim minYvert As vertex_t = v1.Transform(screenspacetransform).PerspectiveDivide()
	Dim midYvert As vertex_t = v2.Transform(screenspacetransform).PerspectiveDivide()
	Dim maxYvert As vertex_t = v3.Transform(screenspacetransform).PerspectiveDivide()
	
	'If(v1.IsInsideViewFrustum() and v2.IsInsideViewFrustum() and v3.IsInsideViewFrustum()) Then'frustum culling
		If use_backfaceculling<>0 Then
			If (minYVert.TriangleAreaTimesTwo(maxYVert, midYVert) >= 0) Then Exit Sub' backfaceculling
		EndIf 
		If maxYvert.GetY()<midYvert.GetY() Then Swap maxYvert,midYvert
		If midYvert.GetY()<minYvert.GetY() Then Swap midYvert,minYvert
		If maxYvert.GetY()<midYvert.GetY() Then Swap maxYvert,midYvert


		Dim As Single area=minYvert.TriangleAreaTimesTwo(maxYvert,midYvert)
		Dim handedness As Integer=(area>=0)

		ScanTriangle(minYvert,midYvert,maxYVert,handedness,texture)
	'EndIf
End Sub
Sub  rendercontext_t.DrawTriangle(v1 As vertex_t, v2 As vertex_t, v3 As vertex_t, texture As texture_t ptr)
		'if(v1.IsInsideViewFrustum() and v2.IsInsideViewFrustum() And v3.IsInsideViewFrustum()) Then
	'		FillTriangle(v1, v2, v3, texture)
'			Exit Sub
		'EndIf
		

		Dim vertices As mdList(vertex_t) 
		Dim auxillaryList As mdList(vertex_t) 
		
		vertices.add(v1)
		vertices.add(v2)
		vertices.add(v3)
		if(ClipPolygonAxis(vertices, auxillaryList, 0) Andalso ClipPolygonAxis(vertices, auxillaryList, 1) Andalso ClipPolygonAxis(vertices, auxillaryList, 2)) Then
			Dim As vertex_t initialVertex = vertices.get(0)
			For i As uinteger= 1 to vertices.size() - 2
				FillTriangle(initialVertex, vertices.get(i), vertices.get(i + 1), texture)
			Next
		EndIf
		vertices.clear()
		auxillaryList.clear()
End Sub
Sub  rendercontext_t.DrawQuad(v1 As vertex_t, v2 As vertex_t, v3 As vertex_t, v4 as vertex_t, texture As texture_t ptr)
		if(v1.IsInsideViewFrustum() and v2.IsInsideViewFrustum() And v3.IsInsideViewFrustum()) Then
			FillTriangle(v1, v2, v3, texture)
			Exit Sub
		EndIf
		if(v1.IsInsideViewFrustum() and v2.IsInsideViewFrustum() And v3.IsInsideViewFrustum()) Then
			FillTriangle(v2, v3, v1, texture)
			Exit Sub
		EndIf
		
'		mdListDeclare(vertex_t)

'		Dim vertices As mdList(vertex_t) 
'		Dim auxillaryList As mdList(vertex_t) 
		
'		vertices.add(v1)
'		vertices.add(v2)
'		vertices.add(v3)

		'if(ClipPolygonAxis(vertices, auxillaryList, 0) And ClipPolygonAxis(vertices, auxillaryList, 1) And ClipPolygonAxis(vertices, auxillaryList, 2)) Then
'			Dim As vertex_t initialVertex = vertices.get(0)
'			For i As uinteger= 1 to vertices.size() - 1
'				FillTriangle(initialVertex, vertices.get(i), vertices.get(i + 1), texture)
'			Next
		'EndIf
End Sub

Function rendercontext_t.ClipPolygonAxis(vertices As mdList(vertex_t) , auxillaryList As mdList(Vertex_t), componentIndex As UInteger) as boolean
		ClipPolygonComponent(vertices, componentIndex, 1.0f, auxillaryList)
		vertices.clear()

		if(auxillaryList.isEmpty()=TRUE) Then
			return FALSE
		EndIf

		ClipPolygonComponent(auxillaryList, componentIndex, -1.0f, vertices)
		auxillaryList.clear()

		if vertices.isEmpty()=TRUE then
			return FALSE
		else
			return TRUE
		EndIf
		'return (not vertices.isEmpty())
End Function
Sub rendercontext_t.ClipPolygonComponent(vertices As mdList(vertex_t) , componentIndex As uinteger, componentFactor As single,result As mdList(vertex_t))
		Dim As vertex_t previousVertex = vertices.get(vertices.size() - 1)
		Dim As single previousComponent = previousVertex.GetByIndex(componentIndex) * componentFactor
		Dim As boolean previousInside = (previousComponent <= previousVertex.GetPosition().GetW())
		
		Dim As mdIterator(vertex_t) it = vertices.iterator()
		while(it.hasNext())
			Dim As vertex_t currentVertex = it.nex()
			Dim As Single currentComponent = currentVertex.GetByIndex(componentIndex) * componentFactor
			Dim As boolean currentInside = (currentComponent <= currentVertex.GetPosition().GetW())

			if((currentInside xor previousInside)=TRUE) Then
				Dim As Single lerpAmt = (previousVertex.GetPosition().GetW() - previousComponent) / _
												((previousVertex.GetPosition().GetW() - previousComponent) - _
												(currentVertex.GetPosition().GetW() - currentComponent))

				result.add(previousVertex.Lerp(currentVertex, lerpAmt))
			EndIf

			if(currentInside) then
				result.add(currentVertex)
			EndIf

			previousVertex = currentVertex
			previousComponent = currentComponent
			previousInside = currentInside
		Wend
End Sub


#EndIf