#Ifndef gradiens_t
#Define gradiens_t
#Include "vector_4d.bi"
#Include "matrix_4d.bi"
#Include "quaternion_4d.bi"
#Include "vertex.bi"

Type gradient_t
	protected:
	Private:
	m_color As vector_4d Ptr
	m_colorXstep As vector_4d
	m_colorYstep As vector_4d

	m_texcoordx As Single ptr
	m_texcoordy As Single Ptr
	m_texcoordxxstep As Single
	m_texcoordxystep As Single
	m_texcoordyxstep As Single
	m_texcoordyystep As Single
	
	m_oneOverZ As Single ptr
	m_oneOverZXStep As Single
	m_oneOverZYStep As Single

 	m_depth As Single Ptr
 	m_depthXStep As Single
	m_depthYStep As Single
	
	m_lightAmt As Single Ptr
	m_lightAmtXStep As Single
	m_lightAmtYStep As single
		
	Public:
	Declare Constructor()
	Declare Constructor(minYvert As vertex_t,midYvert As vertex_t,maxYvert As vertex_t)
	Declare Destructor ()
	
	Declare Function CalcXStep(values As single Ptr,minYVert As vertex_t,midYVert As vertex_t,maxYVert As vertex_t,oneoverz As single ) As Single
	Declare Function CalcYStep(values As single Ptr,minYVert As vertex_t,midYVert As vertex_t,maxYVert As vertex_t,oneoverz As single ) As Single

	Declare Function GetColor(location As uinteger) As vector_4d
	Declare Function GetColorXStep() As vector_4d
	Declare Function GetColorYStep() As vector_4d

	Declare Function GetTexCoordX(location As UInteger) As Single
	Declare Function GetTexCoordY(location As UInteger) As Single
	Declare Function GetTexCoordXXStep() As Single
	Declare Function GetTexCoordXYStep() As Single
	Declare Function GetTexCoordYXStep() As Single
	Declare Function GetTexCoordYYStep() As Single

	Declare Function GetOneOverZ(location As UInteger) As Single
	Declare Function GetOneOverZXStep() As Single
	Declare Function GetOneOverZYStep() As Single
	
	Declare function GetDepth(location As uinteger) As Single
	Declare function GetDepthXStep() As Single
	Declare function GetDepthYStep() As Single
	
	Declare function GetLightAmt(location As uinteger) As Single
	Declare Function GetLightAmtXStep() As Single
	Declare function GetLightAmtYStep() As Single
	
	Declare function Saturate(value As single) As Single

End Type
Constructor gradient_t()

End Constructor
Constructor gradient_t(minYvert As vertex_t,midYvert As vertex_t,maxYvert As vertex_t)
	m_color = New vector_4d[3]
	m_texcoordx = New Single[3]
	m_texcoordy = New Single[3]
	m_oneOverZ = New Single[3]
	m_depth = new Single[3]
	m_lightAmt = New Single[3]
	
	m_depth[0] = minYVert.GetPosition().GetZ()
	m_depth[1] = midYVert.GetPosition().GetZ()
	m_depth[2] = maxYVert.GetPosition().GetZ()
	
	Dim lightDir As vector_4d = vector_4d(0,0,1,1)
	
	m_lightAmt[0] = Saturate(minYVert.GetNormal().GetDotProduct(lightDir)) * 0.9 + 0.1
	m_lightAmt[1] = Saturate(midYVert.GetNormal().GetDotProduct(lightDir)) * 0.9 + 0.1
	m_lightAmt[2] = Saturate(maxYVert.GetNormal().GetDotProduct(lightDir)) * 0.9 + 0.1
		
	m_color[0]=minYvert.GetColor()
	m_color[1]=midYvert.GetColor()
	m_color[2]=maxYvert.GetColor()

	m_texcoordx[0]=minYvert.GetTexCoords().GetX()
	m_texcoordx[1]=midYvert.GetTexCoords().GetX()
	m_texcoordx[2]=maxYvert.GetTexCoords().GetX()
	m_texcoordy[0]=minYvert.GetTexCoords().GetY()
	m_texcoordy[1]=midYvert.GetTexCoords().GetY()
	m_texcoordy[2]=maxYvert.GetTexCoords().GetY()
	
	Dim As Single oneOverdX =1.0/(((	midYvert.GetX()-maxYvert.GetX())* 	_
											(	minYvert.GetY()-maxYvert.GetY()))- 	_
											((	minYvert.GetX()-maxYvert.GetX())*	_
											(	midYvert.GetY()-maxYvert.GetY())))
	Dim As Single oneOverdY = -oneOverdX

	'Dim dC As vector_4d=	vector_4d((( 	m_color[1]-m_color[2])* _
	'										(		minYvert.m_pos.y-maxYvert.m_pos.y))- _
	'										((		m_color[0]-m_color[2])* _
	'										(		midYvert.m_pos.y-maxYvert.m_pos.y)))
		m_colorXstep=((( 		m_color[1].Subs(m_color[2])).Mult(			_
							(		minYvert.GetY()-maxYvert.GetY()))).Subs(	_
							((		m_color[0].Subs(m_color[2])).Mult(			_
							(		midYvert.GetY()-maxYvert.GetY()))))).Mult(oneOverDX)
	
		m_colorYstep=((( 		m_color[1].Subs(m_color[2])).Mult(			_
							(		minYvert.GetX()-maxYvert.GetX()))).Subs(	_
							((		m_color[0].Subs(m_color[2])).Mult(			_
							(		midYvert.GetX()-maxYvert.GetX()))))).Mult(oneOverDY)

						
		m_oneOverZ[0] = 1.0/minYVert.GetPosition().GetW()
		m_oneOverZ[1] = 1.0/midYVert.GetPosition().GetW()
		m_oneOverZ[2] = 1.0/maxYVert.GetPosition().GetW()

		m_texCoordX[0] = minYVert.GetTexCoords().GetX() * m_oneOverZ[0]
		m_texCoordX[1] = midYVert.GetTexCoords().GetX() * m_oneOverZ[1]
		m_texCoordX[2] = maxYVert.GetTexCoords().GetX() * m_oneOverZ[2]

		m_texCoordY[0] = minYVert.GetTexCoords().GetY() * m_oneOverZ[0]
		m_texCoordY[1] = midYVert.GetTexCoords().GetY() * m_oneOverZ[1]
		m_texCoordY[2] = maxYVert.GetTexCoords().GetY() * m_oneOverZ[2]

		m_texCoordXXStep = CalcXStep(m_texcoordx, minYVert, midYVert, maxYVert, oneOverdX)
		m_texCoordXYStep = CalcYStep(m_texcoordx, minYVert, midYVert, maxYVert, oneOverdY)
		m_texCoordYXStep = CalcXStep(m_texcoordy, minYVert, midYVert, maxYVert, oneOverdX)
		m_texCoordYYStep = CalcYStep(m_texcoordy, minYVert, midYVert, maxYVert, oneOverdY)
		
		m_oneOverZXStep = CalcXStep(m_oneOverZ, minYVert, midYVert, maxYVert, oneOverdX)
		m_oneOverZYStep = CalcYStep(m_oneOverZ, minYVert, midYVert, maxYVert, oneOverdY)
		
		m_depthXStep = CalcXStep(m_depth, minYVert, midYVert, maxYVert, oneOverdX)
		m_depthYStep = CalcYStep(m_depth, minYVert, midYVert, maxYVert, oneOverdY)
		
		m_lightAmtXStep = CalcXStep(m_lightAmt, minYVert, midYVert, maxYVert, oneOverdX)
		m_lightAmtYStep = CalcYStep(m_lightAmt, minYVert, midYVert, maxYVert, oneOverdY)
End Constructor
Destructor gradient_t()
 	Delete [] m_color
	Delete [] m_texcoordx
	Delete [] m_texcoordy
	Delete [] m_oneOverZ
	Delete [] m_depth
	Delete [] m_lightAmt
End Destructor
function gradient_t.Saturate(value As single) As Single
	If value > 1.0 Then Return 1.0
	If value < 0.0 Then Return 0.0
	Return value
End Function

Function gradient_t.CalcXStep(values As single ptr,minYVert As vertex_t,midYVert As vertex_t,maxYVert As vertex_t,oneoverdx As single ) As Single
	return	(((values[1] - values[2]) * _
				(minYVert.GetY() - maxYVert.GetY())) - _
				((values[0] - values[2]) * _
				(midYVert.GetY() - maxYVert.GetY()))) * oneoverdx
End Function
Function gradient_t.CalcYStep(values As single Ptr,minYVert As vertex_t,midYVert As vertex_t,maxYVert As vertex_t,oneoverdy As single ) As Single
	return	(((values[1] - values[2]) * _
				(minYVert.GetX() - maxYVert.GetX())) - _
				((values[0] - values[2]) * _
				(midYVert.GetX() - maxYVert.GetX()))) * oneoverdy
End Function

Function gradient_t.GetColor(location As uinteger) As vector_4d
	Return m_color[location]
End Function
Function gradient_t.GetColorXStep() As vector_4d
	Return m_colorXstep
End Function
Function gradient_t.GetColorYStep() As vector_4d
	Return m_colorYstep
End Function
Function gradient_t.GetTexCoordX(location As UInteger) As Single
	Return m_texcoordx[location]
End Function
Function gradient_t.GetTexCoordY(location As UInteger) As Single
	Return m_texcoordy[location]
End Function
Function gradient_t.GetOneOverZ(location As UInteger) As Single
	Return m_oneOverZ[location]
End Function
Function gradient_t.GetTexCoordXXStep() As Single
	Return m_texcoordxxstep
End Function
Function gradient_t.GetTexCoordXYStep() As Single
		Return m_texcoordxystep
End Function
Function gradient_t.GetTexCoordYXStep() As Single
		Return m_texcoordyxstep
End Function
Function gradient_t.GetTexCoordYYStep() As Single
		Return m_texcoordyystep
End Function
Function gradient_t.GetOneOverZXStep() As Single
		Return m_oneOverZXStep
End Function
Function gradient_t.GetOneOverZYStep() As Single
		Return m_oneOverZYStep
End Function
function gradient_t.GetDepth(location As uinteger) As Single
	return m_depth[location] 
End Function
function gradient_t.GetDepthXStep() As Single
	return m_depthXStep
End Function
function gradient_t.GetDepthYStep() As Single 
	return m_depthYStep
End Function
function gradient_t.GetLightAmt(location As uinteger) As Single
	Return m_lightAmt[location]
End Function
Function gradient_t.GetLightAmtXStep() As Single
	Return m_lightAmtXStep
End Function
function gradient_t.GetLightAmtYStep() As Single
	Return m_lightAmtYStep
End Function

#EndIf