#Ifndef stars3d_t_bi
#Define stars3d_t_bi
#Include "framebuffer.bi"

Type stars3d_t
	m_spread As Single
	m_speed As Single
	
	m_starx As Single Ptr
	m_stary As Single Ptr
	m_starz As Single Ptr
	
	m_num_stars As UInteger
	Declare Constructor(num_stars As UInteger,spread As single,speed As Single)
	Declare Destructor()
	
	Declare Sub InitStar(index As uinteger)
	Declare Sub UpdateAndRender(target As framebuffer_t,delta As Single)
	
End Type
Constructor stars3d_t(num_stars As UInteger,spread As single,speed As Single)
		m_starx=New Single[num_stars]
		m_stary=New Single[num_stars]
		m_starz=New Single[num_stars]
		m_spread=spread
		m_speed=speed
		m_num_stars=num_stars-1
		For i As UInteger=0 To num_stars-1
			InitStar(i)
		Next
End Constructor
Destructor stars3d_t()
Delete [] m_starx
Delete [] m_stary
Delete [] m_starz
End Destructor
Sub stars3d_t.InitStar(index As uinteger)
	m_starx[index]=2*(Rnd-0.5)*m_spread
	m_stary[index]=2*(Rnd-0.5)*m_spread
	m_starz[index]=1*(Rnd)*m_spread
End Sub
Sub stars3d_t.UpdateAndRender(target As framebuffer_t,delta As Single)
	'target.Clear(16,0,0,16)
	
	Dim tanHalfFOV As Single=Tan((target.m_fov/2))
	Dim halfwidth As Single		=target.m_width/2
	Dim halfheight As Single 	= target.m_height/2
	
	For i As UInteger=0 To m_num_stars
		m_starz[i]-=(delta/1000)*m_speed
		If m_starz[i]<=0 Then
			InitStar(i)
		EndIf
	Dim x As Single=Int((m_starx[i]/(m_starz[i]*tanHalfFOV))*halfwidth+halfwidth)
	Dim y As Single=Int((m_stary[i]/(m_starz[i]*tanHalfFOV))*halfheight+halfheight)
	If x<0 OrElse x>target.m_width-1 OrElse y<0 OrElse y>target.m_height-1 Then
		InitStar(i)
	Else
		Circle(x,y),m_spread/m_starz[i],RGBA(255,255,255,255),,,,F
		'target.DrawPixel(x,y,255,255,255,255,1)
	EndIf
	Next
End Sub
#endif