#Ifndef vertex_t_bi
#Define vertex_t_bi
#Include "vector_4d.bi"
#Include "matrix_4d.bi"
#Include "quaternion_4d.bi"

Type vertex_t
	Protected:
	Private:
	m_pos As vector_4d
	m_color As vector_4d
	m_normal As vector_4d
	m_texcoords As vector_4d
	
	Public:
	Declare Constructor ()
	Declare Constructor (v As vector_4d)
	Declare Constructor (v As vector_4d,c As vector_4d)
	Declare Constructor (v As vector_4d,c As vector_4d,norm As vector_4d)
	Declare Constructor (v As vector_4d,c As vector_4d,norm As vector_4d, tc As vector_4d)
	Declare Destructor ()

	Declare Sub SetPosition(v As vector_4d)
	Declare Sub SetColor(v As vector_4d)
	Declare Sub SetNormal(v As vector_4d)
	Declare Sub SetTextureCoord(v As vector_4d)
	
	Declare Function	GetX() As Single
	Declare Function	GetY() As Single
	Declare Function	GetZ() As Single
	Declare Function	GetW() As Single
	Declare Function	GetPosition() As vector_4d
	Declare Function	GetColor() As vector_4d
	Declare Function	GetNormal() As vector_4d
	Declare Function	GetTexCoords() As vector_4d
	Declare Function	GetByIndex(index As uinteger) As single

	Declare Function 	toString() As String
   Declare Function  IsInsideViewFrustum() As UInteger
	Declare Function	TriangleAreaTimesTwo(a As vertex_t,b As vertex_t) As Single
	Declare function 	PerspectiveDivide() As vertex_t
'	Declare Function	Transform(transform_mat As matrix_4d,col As vector_4d) As vertex
	Declare Function	Transform(transform_mat As matrix_4d) As vertex_t
	Declare Function  Lerp(other As vertex_t, lerpFactor As single) As vertex_t

	Declare operator 	Cast() As String

End Type
Constructor vertex_t()
	m_pos.SetX(0)
	m_pos.SetY(0)
	m_pos.SetZ(0)
	m_pos.SetW(1)
	m_color.SetX(1)
	m_color.SetY(1)
	m_color.SetZ(1)
	m_color.SetW(1)
	m_texcoords.SetX(0)
	m_texcoords.SetY(0)
	m_texcoords.SetZ(0)
	m_texcoords.SetW(0)
	m_normal.SetX(0)
	m_normal.SetY(0)
	m_normal.SetZ(0)
	m_normal.SetW(0)
End Constructor
Constructor vertex_t(v As vector_4d)
	m_pos.SetX(v.GetX())
	m_pos.SetY(v.GetY())
	m_pos.SetZ(v.GetZ())
	m_pos.SetW(v.GetW())
	m_color.SetX(1)
	m_color.SetY(1)
	m_color.SetZ(1)
	m_color.SetW(1)
	m_texcoords.SetX(0)
	m_texcoords.SetY(0)
	m_texcoords.SetZ(0)
	m_texcoords.SetW(0)
	m_normal.SetX(0)
	m_normal.SetY(0)
	m_normal.SetZ(0)
	m_normal.SetW(0)
End Constructor
Constructor vertex_t(v As vector_4d,c As vector_4d)
	m_pos.SetX(v.GetX())
	m_pos.SetY(v.GetY())
	m_pos.SetZ(v.GetZ())
	m_pos.SetW(v.GetW())
	m_color.SetX(c.GetX())
	m_color.SetY(c.GetY())
	m_color.SetZ(c.GetZ())
	m_color.SetW(c.GetW())
	m_texcoords.SetX(0)
	m_texcoords.SetY(0)
	m_texcoords.SetZ(0)
	m_texcoords.SetW(0)
	m_normal.SetX(0)
	m_normal.SetY(0)
	m_normal.SetZ(0)
	m_normal.SetW(0)
End Constructor
Constructor vertex_t(v As vector_4d,c As vector_4d,norm As vector_4d)
	m_pos.SetX(v.GetX())
	m_pos.SetY(v.GetY())
	m_pos.SetZ(v.GetZ())
	m_pos.SetW(v.GetW())
	m_color.SetX(c.GetX())
	m_color.SetY(c.GetY())
	m_color.SetZ(c.GetZ())
	m_color.SetW(c.GetW())
	m_texcoords.SetX(0)
	m_texcoords.SetY(0)
	m_texcoords.SetZ(0)
	m_texcoords.SetW(0)
	m_normal.SetX(norm.GetX())
	m_normal.SetY(norm.GetY())
	m_normal.SetZ(norm.GetZ())
	m_normal.SetW(norm.GetW())
End Constructor

Constructor vertex_t(v As vector_4d,c As vector_4d,norm As vector_4d,tc As vector_4d)
	m_pos.SetX(v.GetX())
	m_pos.SetY(v.GetY())
	m_pos.SetZ(v.GetZ())
	m_pos.SetW(v.GetW())
	m_color.SetX(c.GetX())
	m_color.SetY(c.GetY())
	m_color.SetZ(c.GetZ())
	m_color.SetW(c.GetW())
	m_texcoords.SetX(tc.GetX())
	m_texcoords.SetY(tc.GetY())
	m_texcoords.SetZ(tc.GetZ())
	m_texcoords.SetW(tc.GetW())
	m_normal.SetX(norm.GetX())
	m_normal.SetY(norm.GetY())
	m_normal.SetZ(norm.GetZ())
	m_normal.SetW(norm.GetW())
End Constructor
'Destructor vertex_t()

'End Destructor
Sub vertex_t.SetPosition(v As vector_4d)
	m_pos.SetX(v.GetX())
	m_pos.SetY(v.GetY())
	m_pos.SetZ(v.GetZ())
	m_pos.SetW(v.GetW())	
End Sub
Sub vertex_t.SetColor(c As vector_4d)
	m_color.SetX(c.GetX())
	m_color.SetY(c.GetY())
	m_color.SetZ(c.GetZ())
	m_color.SetW(c.GetW())
End Sub
Sub vertex_t.SetNormal(n As vector_4d)
	m_normal.SetX(n.GetX())
	m_normal.SetY(n.GetY())
	m_normal.SetZ(n.GetZ())
	m_normal.SetW(n.GetW())
End Sub
Sub vertex_t.SetTextureCoord(tc As vector_4d)
	m_texcoords.SetX(tc.GetX())
	m_texcoords.SetY(tc.GetY())
	m_texcoords.SetZ(tc.GetZ())
	m_texcoords.SetW(tc.GetW())
End Sub
Function vertex_t.GetX() As Single
	Return m_pos.GetX()
End Function
Function vertex_t.GetY() As Single
	Return m_pos.GetY()
End Function
Function vertex_t.GetZ() As Single
	Return m_pos.GetZ()
End Function
Function vertex_t.GetW() As Single
	Return m_pos.GetW()
End Function
Function	vertex_t.GetByIndex(index As uinteger) As Single
	Select Case index
		Case 0: Return m_pos.GetX()
		Case 1: Return m_pos.GetY()
		Case 2: Return m_pos.GetZ()
		Case 3: Return m_pos.GetW()
		Case Else
			Return 0
	End Select
End Function

Function vertex_t.GetPosition() As vector_4d
	Return m_pos
End Function
Function vertex_t.GetColor() As vector_4d
	Return m_color
End Function
Function vertex_t.GetNormal() As vector_4d
	Return m_normal
End Function
Function vertex_t.GetTexCoords() As vector_4d
	Return m_texcoords
End Function
'Function	vertex_t.Transform(transform_mat As matrix_4d, normalTransform As matrix_4d) As vertex_t
Function	vertex_t.Transform(transform_mat As matrix_4d) As vertex_t
	Dim identity As matrix_4d 
	identity=identity.InitIdentity()
	m_normal = identity.Transform(m_normal).Normalize()
	Return vertex_t(transform_mat.Transform(m_pos),m_color, m_normal ,m_texcoords)
End Function
Function vertex_t.PerspectiveDivide() As vertex_t
	'If m_pos.GetW()<EPSILON Then m_pos.SetW(EPSILON)
	'm_pos.SetW(1.0/m_pos.GetW())
	Return vertex_t(vector_4d(m_pos.GetX()/m_pos.GetW(),m_pos.GetY()/m_pos.GetW(),m_pos.GetZ()/m_pos.GetW(),m_pos.GetW()),m_color,m_normal,m_texcoords)
End Function
function vertex_t.Lerp(other As vertex_t, lerpFactor As single) As vertex_t
		return vertex_t(m_pos.Lerp(other.GetPosition(), lerpFactor), m_color.Lerp(other.GetColor(), lerpFactor),m_normal.Lerp(other.GetNormal(), lerpFactor), m_texCoords.Lerp(other.GetTexCoords(), lerpFactor))
End Function
Function	vertex_t.TriangleAreaTimesTwo(a As vertex_t,b As vertex_t) As Single
	Dim x1 As Single = a.GetX()-m_pos.GetX()
	Dim y1 As Single = a.GetY()-m_pos.GetY()
	Dim x2 As Single = b.GetX()-m_pos.GetX()
	Dim y2 As Single = b.GetY()-m_pos.GetY()
	
	Return (x1*y2-x2*y1)
End Function
Function vertex_t.IsInsideViewFrustum() As UInteger
		return _
			Abs(m_pos.GetX()) <= abs(m_pos.GetW()) And _
			Abs(m_pos.GetY()) <= Abs(m_pos.GetW()) And _
			abs(m_pos.GetZ()) <= Abs(m_pos.GetW())
End Function
Function vertex_t.toString() As String
	Return  " " & m_pos.GetX() & " " & m_pos.GetY() & " " & m_pos.GetZ() & " " & m_pos.GetW()
End Function
operator vertex_t.Cast() As String
		Return  " " & m_pos.GetX() & " " & m_pos.GetY() & " " & m_pos.GetZ() & " " & m_pos.GetW()
End Operator
operator = (ByRef lhs As vertex_t, ByRef rhs As vertex_t) As boolean
    
    Return (lhs.GetX() = rhs.GetX()) and (lhs.GetY() = rhs.GetY()) and (lhs.GetZ() = rhs.GetZ()) and (lhs.GetW() = rhs.GetW())
End Operator

#EndIf