#Ifndef quaternion_4d_t
#Define quaternion_4d_t
#Include "vector_2d.bi"
#Include "vector_3d.bi"
#Include "vector_4d.bi"
#Include "matrix_4d.bi"

Type quaternion_4d
	x As Single
	y As Single
	z As Single
	w As Single
	
	Declare Constructor()
	Declare Constructor(x As single,y As single,z As single,w As Single)
	Declare Destructor()
	
	
	Declare Function	getLenght() As Single
	Declare Function	Normalize() As quaternion_4d
	Declare Function	Invert() As quaternion_4d
	Declare Function	Mul(r As quaternion_4d) As quaternion_4d
	Declare Function	Mul(v As vector_3d) As quaternion_4d
	Declare Function 	toString() As String

End Type
Constructor quaternion_4d()
	x=0
	y=0
	z=0
	w=0
End Constructor
Constructor quaternion_4d(x As single,y As single,z As single,w As Single)
	this.x=x
	this.y=y
	this.z=z
	this.w=w
End Constructor
Destructor quaternion_4d()

End Destructor
Function quaternion_4d.GetLenght() As Single
	Return Sqr(x*x + y*y + z*z + w*w)
End Function
Function quaternion_4d.Normalize() As quaternion_4d
	Dim lenght As Single=GetLenght()
	If lenght=0 Then Return This
	x/=lenght
	y/=lenght
	z/=lenght
	w/=lenght
	Return This
End Function
Function quaternion_4d.Invert() As quaternion_4d
	Return quaternion_4d(-x,-y,-z,w)
End Function
Function quaternion_4d.Mul(r As quaternion_4d) As quaternion_4d
	Return quaternion_4d(x*r.w + w*r.x + y*r.z - z*r.y, _
							  	y*r.w + w*r.y + z*r.x - x*r.z, _
							  	z*r.w + w*r.z + x*r.y - y*r.x, _
							 	w*r.w - x*r.x - y*r.y - z*r.z)
End Function
Function quaternion_4d.Mul(v As vector_3d) As quaternion_4d
	Return quaternion_4d(	w*v.x + y*v.z - z*v.y, _
							  		w*v.y + z*v.x - x*v.z, _
							  		w*v.z + x*v.y - y*v.x, _
							  		-x*v.x - y*v.y - z*v.z)
End Function
Function quaternion_4d.toString() As String
Return  " " & x & " " & y & " " & z & " " & w 
End Function

#EndIf