#Ifndef vector_4d_t
#Define vector_4d_t
Type vector_4d
	Protected:
	Private:
	x as Single
	y as Single
	z As Single
	w As Single
	
	Public:
	Declare Constructor	()
	Declare Constructor	(x As single,y As single,z As single,w As Single)
	Declare Constructor	(x As single,y As single,z As Single)
	Declare Constructor	(v As vector_4d)
	Declare Destructor	()

	'setter
	Declare Sub			SetX(x As Single) 
	Declare Sub			SetY(y As Single) 
	Declare Sub			SetZ(z As Single) 
	Declare Sub			SetW(w As Single) 
	'getter
	Declare Function	GetX() As Single
	Declare Function	GetY() As Single
	Declare Function	GetZ() As Single
	Declare Function	GetW() As Single
	'simple math
	Declare Function 	Addi(r As vector_4d) As vector_4d
	Declare Function	Addi(r As Single) As vector_4d
	Declare Function 	Subs(r As vector_4d) As vector_4d
	Declare Function	Subs(r As Single) As vector_4d
	Declare Function 	Mult(r As vector_4d) As vector_4d
	Declare Function	Mult(r As Single) As vector_4d
	Declare Function 	Divi(r As vector_4d) As vector_4d
	Declare Function	Divi(r As Single) As vector_4d
	Declare Function  Lerp(dest As vector_4d, lerpFactor As Single) As vector_4d

	'complex math
	Declare Function	Clone() As vector_4d
	Declare Function 	GetLenght() As Single
	Declare Function  GetDistance(dest As vector_4d) As Single
	Declare Function 	GetAngle() As Single
	Declare Function	GetAngleDeg() As Single
	Declare Function 	GetDirectionVector(dest As vector_4d) As vector_4d
	Declare Function 	GetDirectionAngle(dest As vector_4d) As Single
	Declare Function 	GetDotProduct(v As vector_4d) As Single
	Declare Function 	GetCrossProduct(v As vector_4d) As vector_4d
	Declare Function 	GetInterpolate( A As vector_4d, B As vector_4d, t As Single ) As vector_4d
	Declare Function	TriangleAreaTimesTwo(a As vector_4d,b As vector_4d) As Single
	Declare Function 	toString() As String
	Declare function	Normalize() As vector_4d

	Declare Sub 		SetAngle(angle As Single)
	Declare Sub 		SetAngleDeg(angle As Single)
	Declare Sub 		Rotate(angle As Single)
	Declare Sub 		Turn(angle As Single)
	Declare Sub 		RotateAt(pivot As vector_4d, angle As Single)
	Declare Sub 		TurnAt(v As vector_4d, angle As Single)
	Declare Sub			Position(v As vector_4d)
	Declare Sub			Translate(v As vector_4d)
	Declare Sub			Move(v As vector_4d)
	Declare Sub 		LookAt(v As vector_4d)
	Declare Sub 		Reflect(v As vector_4d)
	Declare Sub			Invert()
	Declare Sub 		Limit(max As Single)
End Type


Constructor vector_4d()
this.x=0
this.y=0
this.z=0
this.w=1
End Constructor
Constructor vector_4d(x As single,y As single,z As single,w As Single)
this.x=x
this.y=y
this.z=z
this.w=w
End Constructor
Constructor vector_4d(x As single,y As single,z As Single)
this.x=x
this.y=y
this.z=z
this.w=1.0
End Constructor
Constructor vector_4d(v As vector_4d)
This.SetX(v.GetX())
this.SetY(v.GetY())
this.SetZ(v.GetZ())
this.SetW(v.GetW())
End Constructor

Destructor vector_4d()

End Destructor
'
'setters
'
Sub vector_4d.SetX(x As Single)
	this.x=x
End Sub
Sub vector_4d.SetY(y As Single)
	this.y=y
End Sub
Sub vector_4d.SetZ(z As Single)
	this.z=z
End Sub
Sub vector_4d.SetW(w As Single)
	this.w=w
End Sub

'
'getters
'
Function vector_4d.GetX() As Single
	Return this.x
End Function
Function vector_4d.GetY() As Single
	Return this.y
End Function
Function vector_4d.GetZ() As Single
	Return this.z
End Function
Function vector_4d.GetW() As Single
	Return this.w
End Function

'
'simple math
'
Function vector_4d.Addi(r As vector_4d) As vector_4d
	Return vector_4d(x+r.GetX(),y+r.GetY(),z+r.GetZ(),w+r.GetW())
End Function
Function	vector_4d.Addi(r As Single) As vector_4d
	Return vector_4d(x+r,y+r,z+r,w+r)	
End Function
Function vector_4d.Subs(r As vector_4d) As vector_4d
		Return vector_4d(x-r.GetX(),y-r.GetY(),z-r.GetZ(),w-r.GetW())
End Function
Function	vector_4d.Subs(r As Single) As vector_4d
		Return vector_4d(x-r,y-r,z-r,w-r)	
End Function
Function vector_4d.Mult(r As vector_4d) As vector_4d
		Return vector_4d(x*r.GetX(),y*r.GetY(),z*r.GetZ(),w*r.GetW())
End Function
Function	vector_4d.Mult(r As Single) As vector_4d
		Return vector_4d(x*r,y*r,z*r,w*r)	
End Function
Function vector_4d.Divi(r As vector_4d) As vector_4d
		Return vector_4d(x/r.GetX(),y/r.GetY(),z/r.GetZ(),w/r.GetW())
End Function
Function	vector_4d.Divi(r As Single) As vector_4d
		Return vector_4d(x/r,y/r,z/r,w/r)	
End Function











Function vector_4d.Clone() As vector_4d
	Return vector_4d(this)
End Function
Function vector_4d.GetLenght() As Single
	return sqr(this.x*this.x + this.y*this.y + this.z*this.z + this.w*this.w)
End Function
Function vector_4d.GetAngle() As Single
	Return ATan2( x, y )
End Function
Function vector_4d.GetAngleDeg() As Single
	Return ATan2( x, y )*180/M_PI
End Function

Function vector_4d.GetDistance(dest As vector_4d) As Single
	Dim delta As vector_4d=dest.Subs(this)
	Dim dist As Single=sqr(delta.x*delta.x+delta.y*delta.y+delta.z*delta.z+delta.w*delta.w)
	Return dist
End Function
Function vector_4d.GetDirectionVector(dest As vector_4d) As vector_4d
	Dim delta As vector_4d=dest.Subs(this)
	Dim rad As Single=ATan2(delta.x,delta.y)
	if rad<0 then rad=M_PI2+rad
	delta.x=Sin(rad)
	delta.y=Cos(rad)
	Return delta
End Function
Function vector_4d.GetDirectionAngle(dest As vector_4d) As Single
	Dim delta As vector_4d=dest.Subs(this)
	Dim rad As Single=ATan2(delta.x,delta.y)
	Return rad
End Function
Function vector_4d.GetDotProduct(v As vector_4d) As Single
	return (this.x * v.x) + (this.y * v.y) + (this.z * v.z) + (this.w * v.w)
End Function
Function vector_4d.GetCrossProduct(v As vector_4d) As vector_4d
		Dim As single x_ = y * v.GetZ() - z * v.GetY()
		Dim As Single y_ = z * v.GetX() - x * v.GetZ()
		Dim As Single z_ = x * v.GetY() - y * v.GetX()

		return vector_4d(x_, y_, z_, 0)
End Function
Function vector_4d.GetInterpolate( A As vector_4d, B As vector_4d, t As Single ) As vector_4d
	return A.Mult(t).Addi(B.Mult((1.0-t)))
End Function
function vector_4d.Lerp( dest As vector_4d, lerpFactor As Single) As vector_4d
		return dest.Subs(This).Mult(lerpFactor).Addi(This)
End Function
sub vector_4d.SetAngle(angle As Single)
	Dim As Single length = Sqr(x*x+y*y)
	this.x = cos(angle)*length
	this.y = sin(angle)*length
End Sub
sub vector_4d.SetAngleDeg(angle  As Single)
	Dim As Single length = Sqr(x*x+y*y)
	angle *= (M_PI/180)
	this.x = cos(angle)*length
	this.y = sin(angle)*length
End Sub
Function vector_4d.Normalize() As vector_4d
	Dim mag As Single=this.GetLenght()
	If mag<EPSILON Then
		return this.Mult(0)
	Else
		dim invLength As Single= 1.0 / mag
		Return this.Mult( invLength)
	endif
End function
Sub vector_4d.Rotate(angle As Single)
	Dim As Single xt = (this.x * cos(angle)) - (this.y * Sin(angle))
	Dim As Single yt = (this.y * Cos(angle)) + (this.x * sin(angle))
	this.x = xt
	this.y = yt
End Sub
Sub vector_4d.RotateAt(pivot As vector_4d,angle As Single)
	Dim As Single xt = pivot.x+Cos(angle)*(this.x-pivot.x) - Sin(angle)*(this.y-pivot.y)
	Dim As Single yt = pivot.y+Sin(angle)*(this.x-pivot.x) + Cos(angle)*(this.y-pivot.y)
	this.x = xt
	this.y = yt
End Sub
'Sub vector_4d.Turn(angle As single)
'	Dim As single l = this.getAngle()
'	Dim As single length = sqr(x*x+y*y)
'	this.x = cos(angle+l)*length
'	this.y = sin(angle+l)*length
'End Sub
Sub vector_4d.TurnAt(v As vector_4d, angle As Single)
	Dim As Single xt = v.x+Cos(angle)*(this.x-v.x) - Sin(angle)*(this.y-v.y)
	Dim As Single yt = v.y+sin(angle)*(this.x-v.x) + Cos(angle)*(this.y-v.y)
	this.x = xt
	this.y = yt
End Sub
'Sub vector_4d.LookAt(v As vector_4d)
'	dim vectorToTarget As vector_4d= vector_4d(v.x - this.x, v.y - this.y, v.z - this.z, v.w - this.w )
'	this.setAngle( vectorToTarget.getAngle())
'End Sub
'Sub vector_4d.Reflect(v As vector_4d)
'	Dim unitNormal As vector_4d=v.Clone()
'	unitNormal.Normalize()
'	this = this.Subs((unitNormal.Mult(((unitNormal.GetDotProduct(this)).Mult(2)))))
'End Sub
Sub vector_4d.Position(v As vector_4d)
	this=v
End Sub
Sub vector_4d.Translate(v As vector_4d)
	This=v
End Sub
Sub vector_4d.Move(v As vector_4d)
	This=this.Addi(v)
End Sub
Sub vector_4d.Invert()
	this.x=-this.x
	this.y=-this.y
	this.z=-this.z
	this.w=this.w
End Sub
Sub vector_4d.Limit(max As Single)
	If (this.GetLenght() > max) Then
		this.Normalize()
		This=this.Mult(max)
	endif
End Sub
Function	vector_4d.TriangleAreaTimesTwo(a As vector_4d,b As vector_4d) As Single
	Dim x1 As Single = a.x-x
	Dim y1 As Single = a.y-y
	Dim x2 As Single = b.x-x
	Dim y2 As Single = b.y-y
	
	Return (x1*y2-x2*y1)
End Function
Function vector_4d.toString() As String
Return  " " & x & " " & y & " " & z & " " & w 
End Function

#endif